{ Copyright (C) Chih-Cherng Chin  1999.       All rights reserved.    }
{                                                                     }
{ The author shall not be liable to the user for any direct, indirect }
{ or consequential loss arising from the use of, or inability to use, }
{ any unit, program or file howsoever caused. No warranty is given    }
{ that the units and programs will work under all circumstances.      }

program finderr;
var
   f : text;
   s1, s2, filename : string;
   i : word;
   done : boolean;
begin
   if ParamCount <> 2 then begin
      writeln('Usage:  finderr <MAP FILE> <ADDRESS>');
      halt(1);
   end;

   assign(f, ParamStr(1));
   reset(f);

   done := FALSE;
   while not eof(f) and not done do begin
      readln(f, s1);
      if pos('Line numbers for ', s1) <> 0 then begin
         delete(s1, 1, pos('(', s1));
         i := pos(')', s1);
         delete(s1, i, length(s1)-i+1);
         filename := s1;
      end else if pos(ParamStr(2), s1) <> 0 then begin
         s1 := concat(s2, s1);
         i := pos(ParamStr(2), s1);
         repeat
            dec(i);
         until s1[i] = ':';
         repeat
            dec(i);
         until s1[i] = ' ';
         delete(s1, i, length(s1)-i+1);
         repeat
            dec(i);
         until s1[i] = ' ';
         delete(s1, 1, i);
         done := TRUE;
      end else begin
         s2 := s1;
      end;
   end;
   if done then
      writeln('Assertion failed at file ', filename, ', line ', s1)
   else begin
      writeln('Can''''t find the failed assertion');
      halt(1);
   end;
end.
